/*    %W% %G%
================================================================================
  Description :
  Author      : Ryu, Byeong-Soon
================================================================================
*/

#ifndef	_CHANNEL_
#define	_CHANNEL_

#include <sys/types.h>
#include "opcode.h"

#define XPORT	6000

#define MAX_BUFFER	8192
#define TEMP_SIZE	8192

#define VX_WANSEONG	0
#define VX_JOHAB	1

typedef struct font_gc_ {
	long  gc, font;
	struct font_gc_  *next;
} FontGC;

typedef struct channel_ {
	char  opcode, byte_order;
	int  c_connected, s_connected;

	long  c_req_len, s_req_len;		/* request data length : number of bytes */
	long  c_str_req_len, c_str_len;
	long  c_ipos, c_opos;
	long  s_ipos, s_opos;
	long  c_font;					/* current ascii font */
	long  c_len_field;				/* length field */
	int  hangul;
	int  input_temp;
	long  res_base, res_mask;
	int  font_loaded;
	int  c_mode;

	FontGC  *font_gc;

	int  cfd, sfd;
	int  ci_buff_size, co_buff_size;
	int  si_buff_size, so_buff_size;
	char  ci_buffer[MAX_BUFFER], co_buffer[MAX_BUFFER];
	char  si_buffer[MAX_BUFFER], so_buffer[MAX_BUFFER];

	int  c_temp_size;
	char  *ctemp, tbuffer[TEMP_SIZE];

	struct channel_  *next;
} Channel;

extern int  VXSockFD, VXLocalPort, VXHanFontType;
extern char  VXHanFontName[100], VXASCFontName[100];

void
VXInitChannel(void),
VXNewChannel(void),
VXFreeChannel(Channel *pre, Channel *ptr),
VXMainLoop(void),
VXProcessInput(fd_set *in_set, fd_set *out_set, fd_set *exc_set),
VXFilterClientInput(Channel *ptr),
VXFilterServerInput(Channel *ptr),
VXMemCopyClient(Channel *ptr, int len),
VXMemCopyServer(Channel *ptr, int len),
VXFilterClientInput(Channel *ptr),
VXFilterServerInput(Channel *ptr),
VXFilterImageText8(Channel *ptr),
VXFilterPolyText8(Channel *ptr),
VXInitHangulFont(Channel *ptr),
VXSetFontGC(Channel *ptr, long gc, long font),
VXFilterGC(Channel *ptr),
VXFilterCopyGC(Channel *ptr),
VXFilterFreeGC(Channel *ptr),
VXCheckSystemByteOrder(void),
VXSetMemShort(Channel *ch, char *ptr, int offset, short val),
VXSetMemLong(Channel *ch, char *ptr, int offset, long val),
VXSetMemMSBShort(char *, int, short),
VXSetMemLSBShort(char *, int, short),
VXSetMemLSBLong(char *, int, long),
VXSetMemMSBLong(char *ptr, int offset, long val);

short
VXMemShort(Channel *ch, char *ptr, int offset);

long
VXMemLong(Channel *ch, char *ptr, int offset),
VXMemMSBLong(char *ptr, int offset),
VXGetFontGC(Channel *ptr, long gc);

int
VXInputClient(Channel *ptr),
VXInputServer(Channel *ptr),
VXOutputClient(Channel *ptr),
VXOutputServer(Channel *ptr);

void convert_ks_to_3(int, int, unsigned char *);
int convert_3_to_display(int, int, int, char [][2]);

#endif	/* _CHANNEL_ */
